#include<bits/stdc++.h>
using namespace std;
inline long long read()
{
	long long s=0,k=1;
	char r=getchar();
	while(!isdigit(r))
	{
		k=(r=='-')?-1:1;
		r=getchar();
	}
	while(isdigit(r))
	{
		s=s*10+(r-'0');
		r=getchar();
	}
	return s*k;
}
#define d read()
#define ll long long
#define Maxn 10010
#define Size 1010
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define Mod 1000000007
ll ksm(ll a,ll b,ll m)
{
	ll ans=1;
	while(b)
	{
		if(b&1) ans=ans*m;
		a=a*a%m;
		b>>=1;
	}
	return ans;
}
struct e
{
	ll u,v,nxt;
}e[Maxn];
ll h[Size],top;
void add(ll u,ll v)
{
	e[top]={u,v,h[u]};
	h[u]=top;
	top++;
}
bool isbridge[Maxn];
ll dfn[Size],low[Size],tjcnt;
void tarjan(ll u)
{
	dfn[u]=low[u]=++tjcnt;
	for(int i=h[u];~i;i=e[i].nxt)
	{
		if(!dfn[e[i].v])
		{
			tarjan(e[i].v);
			if(low[e[i].v]>dfn[u]) isbridge[i]=1;
			low[u]=min(low[e[i].b],dfn[u]);
		}
		else low[u]=min(low[u],dfn[e[i].v]);
	}
}
ll fa[Size],sz[Size],b[Size];
ll find(ll x)
{
	if(x==fa[x]) return x;
	return fa[x]=find(fa[x]);
}
vector<pair<int,int> >bri;
int main()
{
	freopen("barrack.in","r",stdin);
	freopen("barrack.out","w",stdout);
	ll n=d,m=d;
	for(int i=1;i<=n;i++) h[i]=-1,sz[i]=1,fa[i]=i;
	for(int i=0;i<m;i++)
	{
		ll x=d,y=d;
		add(x,y),add(y,x);
	}
	for(int i=1;i<=n;i++)
		if(!dfn[i]) tarjan(i);
	for(int i=0;i<top;i+=2)
	{
		if(isbridge[i])
		{
			bri.pb(mp(e[i].u,e[i].v));
			continue;
		}
		ll x=find(e[i].u),find(e[i].v);
		if(x==y) continue;
		fa[y]=x;
		sz[x]+=sz[y];
	}
	for(int i=0;i<top;i+=2)
	{
		if(isbridge[i]) continue;
		b[find(e[i].v)]++;
	}
	vector<pair<ll,pair<ll,ll> > >now;
	for(int i=1;i<=n;i++)
		if(fa[i]==i) now.pb(mp(i,mp(sz[i],b[i])));
	ll ans=0,num=now.size();
}
/*
First time NOIP
T1
shu shu*1
shou xian zhuan hua
F zhi yong kan C xia mian de xuan ze qing kuang
jie jue

T2
gui yi gou zao
2*n-1 bu hui
dan shi ni shen zhi bu yuan yi gei checker
liu han GGGG
mei ya zhong

T3
tu lun*1
shu shu*2
/jk/jk/jk
kan zhe xu yao tarjan bian shuang zuo
jia nan shi niu B!
bian shuang li ke yi yi tiao bu kan
jiu bian cheng yi ke shu shang de wen ti
mei ge dian li du li qiu ji ke?
mei ge lian tong kuai dan du kao lv

T4
DS*1
zen me yue kan yue xiang cdq er fen,zen me hui shi
bie ba kao chang shang hai rang wo du nai
yue xiang yue dui,dan shi bu hui

tu lun da shi bai
shu shu da sheng li
*/
